## ocaml-atd 1.0.1

=== Makefile ===
# $Id: Makefile 52901 2010-12-10 18:47:39Z martin $

VERSION = 1.0.1

SOURCES = \
  atd_version.ml \
  atd_ast.mli atd_ast.ml \
  atd_annot.mli atd_annot.ml \
  atd_parser.mli atd_parser.mly \
  atd_lexer.mll \
  atd_print.mli atd_print.ml \
  atd_predef.ml \
  atd_check.ml \
  atd_expand.mli atd_expand.ml \
  atd_inherit.mli atd_inherit.ml \
  atd_tsort.mli atd_tsort.ml \
  atd_util.mli atd_util.ml \
  atd_reflect.mli atd_reflect.ml \
  atd_indent.mli atd_indent.ml

MLY = $(filter %.mly, $(SOURCES))
MLL = $(filter %.mll, $(SOURCES))

MLSOURCES = $(patsubst %.mll,%.ml, $(patsubst %.mly,%.ml, $(SOURCES)))
MLI = $(filter %.mli, $(MLSOURCES))
ML = $(filter %.ml, $(MLSOURCES))
CMI = $(patsubst %.ml,%.cmi, $(ML))
CMO = $(patsubst %.ml,%.cmo, $(ML))
CMX = $(patsubst %.ml,%.cmx, $(ML))
O = $(patsubst %.ml,%.o, $(ML))

OCAMLFLAGS = -dtypes -g
OCAMLPACKS = easy-format unix

DOCFILES = \
  atd_ast \
  atd_annot \
  atd_print \
  atd_expand \
  atd_inherit \
  atd_util \
  atd_reflect \
  atd_indent

DOCSOURCES = $(addsuffix .mli, $(DOCFILES))

ifndef PREFIX
  PREFIX = $(shell dirname $$(dirname $$(which ocamlfind)))
  export PREFIX
endif

ifndef BINDIR
  BINDIR = $(PREFIX)/bin
  export BINDIR
endif

.PHONY: default all opt install uninstall

default: all opt

all: VERSION META atd.cma

opt: VERSION META atd.cmxa atdcat

install: META
	test ! -f atdcat || cp atdcat $(BINDIR)/
	test ! -f atdcat.exe || cp atdcat.exe $(BINDIR)/
	ocamlfind install atd META \
		`find $(MLI) $(CMI) $(CMO) $(CMX) $(O) atd.cma atd.a atd.cmxa`

uninstall:
	test ! -f $(BINDIR)/atdcat || rm $(BINDIR)/atdcat
	test ! -f $(BINDIR)/atdcat.exe || rm $(BINDIR)/atdcat.exe 
	ocamlfind remove atd

atd_version.ml: Makefile
	echo 'let version = "$(VERSION)"' > atd_version.ml

META: META.in Makefile
	echo 'version = "$(VERSION)"' > META
	cat META.in >> META

VERSION: Makefile
	echo $(VERSION) > VERSION

%.cmi: %.mli
	ocamlfind ocamlc $(OCAMLFLAGS) -c -package "$(OCAMLPACKS)" $<

%.cmi: %.ml
	ocamlfind ocamlc $(OCAMLFLAGS) -c -package "$(OCAMLPACKS)" $<

%.cmo: %.ml
	ocamlfind ocamlc $(OCAMLFLAGS) -c -package "$(OCAMLPACKS)" $<

%.cmx: %.ml
	ocamlfind ocamlopt $(OCAMLFLAGS) -c -package "$(OCAMLPACKS)" $<

atd_parser.mli: atd_parser.mly
	menhir $<

atd_parser.ml: atd_parser.mly
	menhir $<

atd_lexer.ml: atd_lexer.mll
	ocamllex $<

dep: $(SOURCES) Makefile
	ocamlfind ocamldep -package "$(OCAMLPACKS)" $(MLI) $(ML) > dep

ifneq ($(MAKECMDGOALS),clean)
-include dep
endif

atd.cma: dep $(CMI) $(CMO)
	ocamlfind ocamlc $(OCAMLFLAGS) -o atd.cma -a $(CMO)

atd.cmxa: dep $(CMI) $(CMX)
	ocamlfind ocamlopt $(OCAMLFLAGS) -o atd.cmxa -a $(CMX)

atdcat: dep $(CMI) $(CMX) atdcat.ml
	ocamlfind ocamlopt $(OCAMLFLAGS) -o atdcat \
		-package "$(OCAMLPACKS)" -linkpkg \
		$(CMX) atdcat.ml

.PHONY: doc
doc: odoc/index.html atdcat
	cd manual; $(MAKE)

odoc/index.html: $(CMI)
	mkdir -p odoc
	ocamlfind ocamldoc -d odoc -html \
		-t 'ATD library documentation' \
		-package "$(OCAMLPACKS)" $(DOCSOURCES)

.PHONY: test
test: atdcat test.atd test2.atd
	./atdcat test.atd > test.out
	./atdcat test.out > test.out.out
	cmp test.out test.out.out
	./atdcat -x test2.atd > test2.out

.PHONY: clean
clean:
	rm -f dep
	rm -f $(CMI) $(CMO) $(CMX) $(O)
	rm -f $(patsubst %.mly,%.mli, $(MLY))
	rm -f $(patsubst %.mly,%.ml, $(MLY))
	rm -f $(patsubst %.mll,%.ml, $(MLL))
	rm -f atdcat.cm[ioxa] atdcat.o atdcat.cma atdcat.cmxa
	rm -rf odoc
	cd manual; $(MAKE) clean

.PHONY: release
release:
	./release.sh

=== manual/Makefile ===
# $Id: Makefile 52901 2010-12-10 18:47:39Z martin $

# `make pdf' requires pdflatex and builds readme.pdf
# `make txt' requires hevea and builds readme.txt
# `make html' requires hevea and builds readme.html

TEXFILES = atd-manual atd-body

.PHONY: all pdf txt html clean

all: pdf txt html
pdf: atd-manual.pdf
txt: atd-manual.txt
html: atd-manual.html

atd-manual.tex: ../atd_version.ml atd-manual.mlx
	OCAMLPATH=../..:$$OCAMLPATH camlmix atd-manual.mlx -o atd-manual.tex

atd-body.tex: ../atd_version.ml macros.ml atd-body.mlx
	OCAMLPATH=../..:$$OCAMLPATH camlmix atd-body.mlx -o atd-body.tex

atd-manual.txt: $(addsuffix .tex, $(TEXFILES))
	rm -f *.aux
	hevea -fix -text atd-manual
	cp atd-manual.txt ../README

atd-manual.html: $(addsuffix .tex, $(TEXFILES))
	rm -f *.aux
	hevea -fix atd-manual

atd-manual.pdf: $(addsuffix .tex, $(TEXFILES))
	pdflatex atd-manual
	pdflatex atd-manual

clean:
	rm -f *.aux *.toc *.log *.out *.haux *.htoc *.fls \
		atd-manual.pdf atd-manual.txt atd-manual.html

=== debian/changelog ===
ocaml-atd (1.0.1-1) unstable; urgency=low

  * Team upload
  * New upstream release
  * Bump Standards-Version to 3.9.2

 -- Stéphane Glondu <glondu@debian.org>  Mon, 11 Jul 2011 00:01:50 +0200

ocaml-atd (0.9.2-2) unstable; urgency=low

  * Add doc-base for ATD manual

 -- Sylvain Le Gall <gildor@debian.org>  Sat, 04 Dec 2010 23:43:36 +0100

ocaml-atd (0.9.2-1) unstable; urgency=low

  * Initial release. (Closes: #605670)

 -- Sylvain Le Gall <gildor@debian.org>  Thu, 02 Dec 2010 22:22:54 +0100

=== debian/control ===
Source: ocaml-atd
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: 
  Sylvain Le Gall <gildor@debian.org>
Build-Depends:
  ocaml-nox (>= 3.11.1-3~),
  ocaml-findlib,
  dh-ocaml (>= 0.9~),
  debhelper (>= 7.0.50~),
  menhir, libeasy-format-ocaml-dev
Standards-Version: 3.9.2
Homepage: http://oss.wink.com/atd/
Vcs-Git: git://git.debian.org/git/pkg-ocaml-maint/packages/ocaml-atd.git
Vcs-Browser: http://git.debian.org/?p=pkg-ocaml-maint/packages/ocaml-atd.git

Package: libatd-ocaml-dev
Architecture: any
Depends: ${ocaml:Depends}, ${misc:Depends}, ${shlibs:Depends}
Provides: ${ocaml:Provides}
Recommends: ocaml-findlib
Description: syntax for cross-language data types in OCaml
 ATD stands for Adjustable Type Definitions. It is a type definition
 language designed to accommodate a variety of programming languages and
 data formats by the means of target-specific annotations. It supports
 sum types, parametrized types and inheritance. The library provides a
 parser and other tools useful for manipulating ATD type definitions.

Package: libatd-ocaml
Architecture: any
Depends: ${ocaml:Depends}, ${misc:Depends}
Provides: ${ocaml:Provides}
Recommends: ocaml-findlib
Description: syntax for cross-language data types in OCaml
 ATD stands for Adjustable Type Definitions. It is a type definition
 language designed to accommodate a variety of programming languages and
 data formats by the means of target-specific annotations. It supports
 sum types, parametrized types and inheritance. The library provides a
 parser and other tools useful for manipulating ATD type definitions.
 .
 This package contains the shared runtime libraries.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DESTDIR=$(CURDIR)/debian/tmp

include /usr/share/ocaml/ocamlvars.mk

OCAMLFIND_DESTDIR=$(DESTDIR)/$(OCAML_STDLIB_DIR)
export OCAMLFIND_DESTDIR
OCAMLFIND_LDCONF=ignore
export OCAMLFIND_LDCONF

%:
	dh --with ocaml $@

.PHONY: override_dh_auto_build
override_dh_auto_build:
ifeq ($(OCAML_HAVE_OCAMLOPT),yes)
	$(MAKE)
else
	$(MAKE) all
endif 

.PHONY: override_dh_auto_install
override_dh_auto_install:
	mkdir -p '$(DESTDIR)/usr/bin'
	mkdir -p '$(OCAMLFIND_DESTDIR)'
	make install 'BINDIR=$(DESTDIR)/usr/bin' 

.PHONY: override_dh_install
override_dh_install:
	dh_install --fail-missing

.PHONY: override_dh_auto_test
override_dh_auto_clean:
	true

.PHONY: override_dh_auto_clean
override_dh_auto_clean:
	$(MAKE) clean

debian/atdcat.1: debian/atdcat.mkd
	pandoc -s -w man $^ -o $@

=== debian/watch ===
version=3
http://oss.wink.com/atd/ atd-([\d\.]*)\.tar\.gz

## ocaml-atd 1.0.3

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,4 @@
-# $Id: Makefile 52901 2010-12-10 18:47:39Z martin $
-
-VERSION = 1.0.1
+VERSION = 1.0.3
 
 SOURCES = \
   atd_version.ml \
@@ -8,6 +6,7 @@
   atd_annot.mli atd_annot.ml \
   atd_parser.mli atd_parser.mly \
   atd_lexer.mll \
+  atd_doc_lexer.mll atd_doc.mli atd_doc.ml \
   atd_print.mli atd_print.ml \
   atd_predef.ml \
   atd_check.ml \
@@ -30,11 +29,12 @@
 O = $(patsubst %.ml,%.o, $(ML))
 
 OCAMLFLAGS = -dtypes -g
-OCAMLPACKS = easy-format unix
+OCAMLPACKS = easy-format unix str
 
 DOCFILES = \
   atd_ast \
   atd_annot \
+  atd_doc \
   atd_print \
   atd_expand \
   atd_inherit \
@@ -54,7 +54,7 @@
   export BINDIR
 endif
 
-.PHONY: default all opt install uninstall
+.PHONY: default all opt install uninstall reinstall
 
 default: all opt
 
@@ -70,8 +70,12 @@
 
 uninstall:
 	test ! -f $(BINDIR)/atdcat || rm $(BINDIR)/atdcat
-	test ! -f $(BINDIR)/atdcat.exe || rm $(BINDIR)/atdcat.exe 
+	test ! -f $(BINDIR)/atdcat.exe || rm $(BINDIR)/atdcat.exe
 	ocamlfind remove atd
+
+reinstall:
+	$(MAKE) uninstall || :
+	$(MAKE) install
 
 atd_version.ml: Makefile
 	echo 'let version = "$(VERSION)"' > atd_version.ml
@@ -102,6 +106,9 @@
 	menhir $<
 
 atd_lexer.ml: atd_lexer.mll
+	ocamllex $<
+
+atd_doc_lexer.ml: atd_doc_lexer.mll
 	ocamllex $<
 
 dep: $(SOURCES) Makefile
@@ -139,6 +146,29 @@
 	cmp test.out test.out.out
 	./atdcat -x test2.atd > test2.out
 
+.PHONY: docdemo
+docdemo: atdcat test.atd
+	./atdcat test.atd -html-doc -strip ocaml > test-out.atd
+	caml2html -ext html:cat test-out.atd -nf
+	sed -i -e 's!</style>!\
+div.atd-doc { \
+  border-left: solid #ccc 6px; \
+  margin-bottom: 50px; \
+  margin-left: 30px; \
+  padding: 5px; \
+} \
+div.atd-doc p { \
+  margin: 0px; \
+  padding: 0px; \
+} \
+div.atd-doc pre { \
+  margin-left: 40px; \
+  margin-right: 0px; \
+  margin-top: 10px; \
+  margin-bottom: 10px; \
+} \
+</style>!' test-out.atd.html
+
 .PHONY: clean
 clean:
 	rm -f dep

=== debian/changelog ===
ocaml-atd (1.0.3-1) unstable; urgency=low

  [ Sylvain Le Gall ]
  * Remove Sylvain Le Gall from uploaders

  [ Hendrik Tews ]
  * fix watch file and hompage
  * new upstream version
  * add myself as uploader
  * bump debhelper compat level and standards version
  * update package description
  * update copyright
  * fix patches
    - delete old patch
    - add makefile.patch for byte compilation and installation of some ml files
    - add lintian-allows-to.patch to fix lintian allows warning
    - add build-manual-without-install.patch to build manual/atd-manual.html
      without prior installation of the atd library
  * update rules and other debhelper files
  * fix build dependencies
  * install pdf version of manual
  * enable tests
  * rewrite/improve man page

 -- Hendrik Tews <hendrik@askra.de>  Thu, 06 Jun 2013 10:21:07 +0200

=== debian/control ===
Source: ocaml-atd
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Hendrik Tews <hendrik@askra.de>
Build-Depends:
  ocaml-nox (>= 3.11.1-3~),
  ocaml-best-compilers,
  ocaml-findlib,
  dh-ocaml (>= 0.9~),
  debhelper (>= 9),
  menhir, 
  libeasy-format-ocaml-dev,
  hevea,
  camlmix,
  libfindlib-ocaml-dev,
  libcaml2html-ocaml-dev,
  texlive-latex-extra
Standards-Version: 3.9.4
Homepage: http://mjambon.com/atdgen
Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/ocaml-atd.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ocaml-maint/packages/ocaml-atd.git

Package: libatd-ocaml-dev
Architecture: any
Depends: ${ocaml:Depends}, ${misc:Depends}, ${shlibs:Depends}
Provides: ${ocaml:Provides}
Recommends: ocaml-findlib
Description: syntax for cross-language data types in OCaml - development files
 ATD stands for Adjustable Type Definitions. It is a type definition
 language designed to accommodate a variety of programming languages and
 data formats by the means of target-specific annotations. It supports
 sum types, parametrized types and inheritance. The library provides a
 parser and other tools useful for manipulating ATD type definitions.
 .
 This package contains the development files needed for programming
 with the library.

Package: libatd-ocaml
Architecture: any
Depends: ${ocaml:Depends}, ${misc:Depends}, ${shlibs:Depends}
Provides: ${ocaml:Provides}
Recommends: ocaml-findlib
Description: syntax for cross-language data types in OCaml - plugins
 ATD stands for Adjustable Type Definitions. It is a type definition
 language designed to accommodate a variety of programming languages and
 data formats by the means of target-specific annotations. It supports
 sum types, parametrized types and inheritance. The library provides a
 parser and other tools useful for manipulating ATD type definitions.
 .
 This package contains the shared runtime libraries and plugins.

## ocaml-atd 1.1.1

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,9 @@
-VERSION = 1.0.3
+VERSION = 1.1.1
+ifeq "$(shell ocamlc -config |grep os_type)" "os_type: Win32"
+EXE=.exe
+else
+EXE=
+endif
 
 SOURCES = \
   atd_version.ml \
@@ -27,6 +32,8 @@
 CMO = $(patsubst %.ml,%.cmo, $(ML))
 CMX = $(patsubst %.ml,%.cmx, $(ML))
 O = $(patsubst %.ml,%.o, $(ML))
+INSTALL_EXTRAS = atd_check.ml atd_doc_lexer.mll atd_doc_lexer.ml \
+		 atd_lexer.mll atd_lexer.ml atd_predef.ml atd_version.ml
 
 OCAMLFLAGS = -dtypes -g
 OCAMLPACKS = easy-format unix str
@@ -60,13 +67,14 @@
 
 all: VERSION META atd.cma
 
-opt: VERSION META atd.cmxa atdcat
+opt: VERSION META atd.cmxa atdcat$(EXE)
 
 install: META
 	test ! -f atdcat || cp atdcat $(BINDIR)/
 	test ! -f atdcat.exe || cp atdcat.exe $(BINDIR)/
 	ocamlfind install atd META \
-		`find $(MLI) $(CMI) $(CMO) $(CMX) $(O) atd.cma atd.a atd.cmxa`
+	 $(MLI) $(CMI) $(CMO) $(CMX) $(O) atd.cma atd.a atd.cmxa \
+         $(INSTALL_EXTRAS)
 
 uninstall:
 	test ! -f $(BINDIR)/atdcat || rm $(BINDIR)/atdcat
@@ -124,13 +132,13 @@
 atd.cmxa: dep $(CMI) $(CMX)
 	ocamlfind ocamlopt $(OCAMLFLAGS) -o atd.cmxa -a $(CMX)
 
-atdcat: dep $(CMI) $(CMX) atdcat.ml
-	ocamlfind ocamlopt $(OCAMLFLAGS) -o atdcat \
+atdcat$(EXE): dep $(CMI) $(CMX) atdcat.ml
+	ocamlfind ocamlopt $(OCAMLFLAGS) -o atdcat$(EXE) \
 		-package "$(OCAMLPACKS)" -linkpkg \
 		$(CMX) atdcat.ml
 
 .PHONY: doc
-doc: odoc/index.html atdcat
+doc: odoc/index.html atdcat$(EXE)
 	cd manual; $(MAKE)
 
 odoc/index.html: $(CMI)
@@ -140,14 +148,14 @@
 		-package "$(OCAMLPACKS)" $(DOCSOURCES)
 
 .PHONY: test
-test: atdcat test.atd test2.atd
+test: atdcat$(EXE) test.atd test2.atd
 	./atdcat test.atd > test.out
 	./atdcat test.out > test.out.out
 	cmp test.out test.out.out
 	./atdcat -x test2.atd > test2.out
 
 .PHONY: docdemo
-docdemo: atdcat test.atd
+docdemo: atdcat$(EXE) test.atd
 	./atdcat test.atd -html-doc -strip ocaml > test-out.atd
 	caml2html -ext html:cat test-out.atd -nf
 	sed -i -e 's!</style>!\
@@ -172,11 +180,12 @@
 .PHONY: clean
 clean:
 	rm -f dep
-	rm -f $(CMI) $(CMO) $(CMX) $(O)
+	rm -f atd_version.ml
+	rm -f $(CMI) $(CMO) $(CMX) $(O) *.annot *.cma *.cmxa *.a
 	rm -f $(patsubst %.mly,%.mli, $(MLY))
 	rm -f $(patsubst %.mly,%.ml, $(MLY))
 	rm -f $(patsubst %.mll,%.ml, $(MLL))
-	rm -f atdcat.cm[ioxa] atdcat.o atdcat.cma atdcat.cmxa
+	rm -f atdcat.cm[ioxa] atdcat.o atdcat.cma atdcat.cmxa atdcat$(EXE)
 	rm -rf odoc
 	cd manual; $(MAKE) clean

=== debian/changelog ===
ocaml-atd (1.1.1-2) unstable; urgency=medium

  * Team upload
  * Fix package build on bytecode architectures

 -- Stéphane Glondu <glondu@debian.org>  Fri, 31 Jan 2014 17:30:19 +0100

ocaml-atd (1.1.1-1) unstable; urgency=medium

  * Team upload
  * New upstream release
  * Bump Standards-Version to 3.9.5

 -- Stéphane Glondu <glondu@debian.org>  Wed, 29 Jan 2014 14:33:16 +0100

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
#export DH_OPTIONS=-v

DESTDIR=$(CURDIR)/debian/tmp

include /usr/share/ocaml/ocamlvars.mk

OCAMLFIND_DESTDIR=$(DESTDIR)/$(OCAML_STDLIB_DIR)
export OCAMLFIND_DESTDIR
OCAMLFIND_LDCONF=ignore
export OCAMLFIND_LDCONF

%:
	dh $@ --with ocaml

.PHONY: override_dh_auto_build
override_dh_auto_build:
	$(MAKE) all
ifeq ($(OCAML_HAVE_OCAMLOPT),yes)
	$(MAKE) opt
else
	$(MAKE) atdcat.byte
endif
	$(MAKE) odoc/index.html
	$(MAKE) -C manual html pdf

.PHONY: override_dh_auto_install
override_dh_auto_install:
	mkdir -p '$(DESTDIR)/usr/bin'
	mkdir -p '$(OCAMLFIND_DESTDIR)'
	make install 'BINDIR=$(DESTDIR)/usr/bin'

.PHONY: override_dh_install
override_dh_install:
	dh_install --fail-missing

# override this to prevent dh_auto_clean to try make distclean, 
# which creates atd_version.ml
.PHONY: override_dh_auto_clean
override_dh_auto_clean:
	$(MAKE) clean

## ocaml-atd 1.1.2

=== Makefile ===
--- 
+++ 
@@ -1,8 +1,18 @@
-VERSION = 1.1.1
+VERSION = 1.1.2
 ifeq "$(shell ocamlc -config |grep os_type)" "os_type: Win32"
 EXE=.exe
 else
 EXE=
+endif
+
+NATDYNLINK := $(shell if [ -f `ocamlc -where`/dynlink.cmxa ]; then \
+                        echo YES; \
+                      else \
+                        echo NO; \
+                      fi)
+
+ifeq "${NATDYNLINK}" "YES"
+CMXS=atd.cmxs
 endif
 
 SOURCES = \
@@ -17,7 +27,7 @@
   atd_check.ml \
   atd_expand.mli atd_expand.ml \
   atd_inherit.mli atd_inherit.ml \
-  atd_tsort.mli atd_tsort.ml \
+  atd_sort.ml \
   atd_util.mli atd_util.ml \
   atd_reflect.mli atd_reflect.ml \
   atd_indent.mli atd_indent.ml
@@ -67,13 +77,13 @@
 
 all: VERSION META atd.cma
 
-opt: VERSION META atd.cmxa atdcat$(EXE)
+opt: VERSION META atd.cmxa $(CMXS) atdcat$(EXE)
 
 install: META
 	test ! -f atdcat || cp atdcat $(BINDIR)/
 	test ! -f atdcat.exe || cp atdcat.exe $(BINDIR)/
 	ocamlfind install atd META \
-	 $(MLI) $(CMI) $(CMO) $(CMX) $(O) atd.cma atd.a atd.cmxa \
+	 $(MLI) $(CMI) $(CMO) $(CMX) $(CMXS) $(O) atd.cma atd.a atd.cmxa \
          $(INSTALL_EXTRAS)
 
 uninstall:
@@ -132,10 +142,19 @@
 atd.cmxa: dep $(CMI) $(CMX)
 	ocamlfind ocamlopt $(OCAMLFLAGS) -o atd.cmxa -a $(CMX)
 
+atd.cmxs: dep $(CMI) $(CMX)
+	ocamlfind ocamlopt $(OCAMLFLAGS) -shared -o $(CMXS) $(CMX)
+
 atdcat$(EXE): dep $(CMI) $(CMX) atdcat.ml
 	ocamlfind ocamlopt $(OCAMLFLAGS) -o atdcat$(EXE) \
 		-package "$(OCAMLPACKS)" -linkpkg \
 		$(CMX) atdcat.ml
+
+unit-tests$(EXE): dep $(CMI) $(CMX) unit_tests.ml
+	ocamlfind ocamlopt $(OCAMLFLAGS) -o unit-tests$(EXE) \
+		-package "$(OCAMLPACKS)" -linkpkg \
+		$(CMX) unit_tests.ml
+
 
 .PHONY: doc
 doc: odoc/index.html atdcat$(EXE)
@@ -148,7 +167,8 @@
 		-package "$(OCAMLPACKS)" $(DOCSOURCES)
 
 .PHONY: test
-test: atdcat$(EXE) test.atd test2.atd
+test: atdcat$(EXE) unit-tests$(EXE) test.atd test2.atd
+	./unit-tests$(EXE)
 	./atdcat test.atd > test.out
 	./atdcat test.out > test.out.out
 	cmp test.out test.out.out
@@ -186,6 +206,7 @@
 	rm -f $(patsubst %.mly,%.ml, $(MLY))
 	rm -f $(patsubst %.mll,%.ml, $(MLL))
 	rm -f atdcat.cm[ioxa] atdcat.o atdcat.cma atdcat.cmxa atdcat$(EXE)
+	rm -f unit-tests$(EXE)
 	rm -rf odoc
 	cd manual; $(MAKE) clean

=== debian/changelog ===
ocaml-atd (1.1.2-1build4) bionic; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 28 Oct 2017 16:47:14 +0200

ocaml-atd (1.1.2-1build3) artful; urgency=high

  * No change rebuild against ocaml 4.04.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 03 Jul 2017 12:53:27 +0100

ocaml-atd (1.1.2-1build2) xenial; urgency=medium

  * Rebuild for new OCaml ABIs.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 12 Feb 2016 12:26:49 +0000

ocaml-atd (1.1.2-1build1) xenial; urgency=medium

  * No-change rebuild against ocaml 4.02.

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@canonical.com>  Thu, 05 Nov 2015 10:19:58 -0600

ocaml-atd (1.1.2-1) unstable; urgency=medium

  * Team upload
  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Wed, 06 Aug 2014 11:03:09 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: ocaml-atd
 Section: ocaml
 Priority: optional
-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders: Hendrik Tews <hendrik@askra.de>
 Build-Depends:
   ocaml-nox (>= 3.11.1-3~),
@@ -16,7 +17,7 @@
   libfindlib-ocaml-dev,
   libcaml2html-ocaml-dev,
   texlive-latex-extra
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 Homepage: http://mjambon.com/atdgen
 Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/ocaml-atd.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ocaml-maint/packages/ocaml-atd.git

=== debian/rules ===
--- 
+++ 
@@ -23,7 +23,7 @@
 ifeq ($(OCAML_HAVE_OCAMLOPT),yes)
 	$(MAKE) opt
 else
-	$(MAKE) atdcat.byte
+	$(MAKE) atdcat.byte unit-tests.byte
 endif
 	$(MAKE) odoc/index.html
 	$(MAKE) -C manual html pdf

=== debian/watch ===
version=3
http://mjambon.com/releases/atd \
.*/atd/atd[\-\._](\d\S*)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)

## ocaml-atd 2.0.0

=== Makefile ===
JBUILDER ?= jbuilder

all:
	$(JBUILDER) build

tests:
	$(JBUILDER) runtest

check: tests

clean:
	$(JBUILDER) clean

all-supported-ocaml-versions:
	$(JBUILDER) runtest --dev --workspace jbuild-workspace.dev

doc:
	cd doc && sphinx-build . _build

livedoc:
	cd doc && sphinx-autobuild . _build \
	  -p 8888 -q  --host $(shell hostname) -r '\.#.*'

.PHONY: all tests clean check doc livedoc

=== atdgen-doc/Makefile ===
.PHONY: default clean

ifndef BRANCH
  GITBRANCH = $(shell git branch \
            | sed -e '/^[^*]/d' -e 's/* \(.*\)/\1/' )
  ifneq ($(GITBRANCH),gh-pages)
    BRANCH = master
  else
    BRANCH = $(GITBRANCH)
  endif
endif

default:
	$(MAKE) -f Makefile.$(BRANCH)

clean:
	$(MAKE) -f Makefile.$(BRANCH) clean
	rm -f *~

=== atdgen-doc/src/Makefile ===
MANDIR = ../man1
HTMLDIR = ../html

.PHONY: default all man html clean
default: all
all: man html

man: \
  $(MANDIR)/atd.1 \
  $(MANDIR)/atdgen.1

html: \
  $(HTMLDIR)/atd-syntax.html \
  $(HTMLDIR)/atdgen.html \
  $(HTMLDIR)/biniou-format.txt \
  $(HTMLDIR)/index.html \
  $(HTMLDIR)/tutorial.html

$(MANDIR)/atd.1: atd-syntax.md
	mkdir -p $(MANDIR)
	pandoc $< -o $@ -t man -s

$(MANDIR)/atdgen.1: atdgen.md
	mkdir -p $(MANDIR)
	pandoc $< -o $@ -t man -s

$(HTMLDIR)/atd-syntax.html: atd-syntax.md atdgen.css
	mkdir -p $(HTMLDIR)
	cp atdgen.css $(HTMLDIR)
	pandoc $< -o $@ -t html5 -s --toc -c atdgen.css

$(HTMLDIR)/atdgen.html: atdgen.md atdgen.css
	mkdir -p $(HTMLDIR)
	cp atdgen.css $(HTMLDIR)
	pandoc $< -o $@ -t html5 -s --toc -c atdgen.css

$(HTMLDIR)/tutorial.html: tutorial.md atdgen.css
	mkdir -p $(HTMLDIR)
	cp atdgen.css $(HTMLDIR)
	pandoc $< -o $@ -t html5 -s --toc -c atdgen.css

$(HTMLDIR)/index.html: index.md atdgen.css
	mkdir -p $(HTMLDIR)
	cp atdgen.css $(HTMLDIR)
	pandoc $< -o $@ -t html5 -s --toc -c atdgen.css

$(HTMLDIR)/biniou-format.txt: biniou-format.txt
	cp $< $@

clean:
	rm -f *~
	rm -rf $(MANDIR) $(HTMLDIR)

=== debian/changelog ===
ocaml-atd (2.0.0-3) unstable; urgency=medium

  * Team upload
  * Fix call to "jbuilder install" (Closes: #917733)

 -- Stéphane Glondu <glondu@debian.org>  Wed, 09 Jan 2019 16:49:20 +0100

ocaml-atd (2.0.0-2) unstable; urgency=medium

  * Team upload
  * Remove a test that fails on i386 (Closes: #901823)

 -- Stéphane Glondu <glondu@debian.org>  Sat, 08 Dec 2018 10:39:31 +0100

ocaml-atd (2.0.0-1) unstable; urgency=medium

  * Team upload
  * New upstream release
    - add default-jdk-headless to Build-Depends
  * Update Homepage
  * Update debian/watch

 -- Stéphane Glondu <glondu@debian.org>  Mon, 25 Jun 2018 11:04:00 +0200

ocaml-atd (1.12.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 1.12.0
    - switch to jbuilder
    - latex and html docs cannot be generated anymore
    - drop patch to toplevel Makefile
  * The new upstream release now includes src:atdgen and its binary packages
    - added binary packages libatdgen-ocaml-dev and libatdgen-ocaml
    - added build dependency on libbiniou-ocaml-dev and libyojson-ocaml-dev
  * Bump debhelper compat to 11
  * Remove trailing whitespaces
  * Bump Standards-Version to 4.1.4 (no changes required)
  * Switch Vcs-* fields to salsa
  * debian/copyright: add missing bit from license
  * debian/rules: use dh_missing --list-missing instead of
    dh_install --fail-missing
  * add autopkgtest

 -- Johannes Schauer <josch@debian.org>  Wed, 23 May 2018 08:40:27 +0200

=== debian/control ===
--- 
+++ 
@@ -1,26 +1,29 @@
 Source: ocaml-atd
 Section: ocaml
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
+Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders: Hendrik Tews <hendrik@askra.de>
 Build-Depends:
+  dune (>= 1.6.2),
+  opam,
   ocaml-nox (>= 3.11.1-3~),
   ocaml-best-compilers,
   ocaml-findlib,
   dh-ocaml (>= 0.9~),
-  debhelper (>= 9),
-  menhir, 
+  debhelper (>= 11),
+  menhir,
   libeasy-format-ocaml-dev,
   hevea,
   camlmix,
   libfindlib-ocaml-dev,
   libcaml2html-ocaml-dev,
-  texlive-latex-extra
-Standards-Version: 3.9.5
-Homepage: http://mjambon.com/atdgen
-Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/ocaml-atd.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ocaml-maint/packages/ocaml-atd.git
+  libbiniou-ocaml-dev (>= 1.0.6),
+  libyojson-ocaml-dev,
+  default-jdk-headless,
+Standards-Version: 4.1.4
+Homepage: https://github.com/mjambon/atd
+Vcs-Git: https://salsa.debian.org/ocaml-team/ocaml-atd.git
+Vcs-Browser: https://salsa.debian.org/ocaml-team/ocaml-atd
 
 Package: libatd-ocaml-dev
 Architecture: any
@@ -50,3 +53,33 @@
  parser and other tools useful for manipulating ATD type definitions.
  .
  This package contains the shared runtime libraries and plugins.
+
+Package: libatdgen-ocaml-dev
+Architecture: any
+Depends: ${ocaml:Depends}, ${misc:Depends}, ${shlibs:Depends}
+Provides: ${ocaml:Provides}
+Recommends: ocaml-findlib
+Description: OCaml code generator for biniou and JSON - executable and dev files
+ Atdgen is a command-line program that takes as input type definitions in
+ the ATD syntax and produces OCaml code suitable for data serialization
+ and deserialization. Two data formats are currently supported, these are
+ biniou and JSON.
+ .
+ This package contains the adtgen executable and the files necessary
+ for programming with the library.
+
+Package: libatdgen-ocaml
+Architecture: any
+Depends:
+ ${ocaml:Depends},
+ ${misc:Depends},
+ ${shlibs:Depends}
+Provides: ${ocaml:Provides}
+Recommends: ocaml-findlib
+Description: OCaml code generator for biniou and JSON - plugins
+ Atdgen is a command-line program that takes as input type definitions in
+ the ATD syntax and produces OCaml code suitable for data serialization
+ and deserialization. Two data formats are currently supported, these are
+ biniou and JSON.
+ .
+ This package contains the shared runtime libraries (plugin).

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
#export DH_OPTIONS=-v

DESTDIR=$(CURDIR)/debian/tmp

include /usr/share/ocaml/ocamlvars.mk

OCAMLFIND_DESTDIR=$(DESTDIR)/$(OCAML_STDLIB_DIR)
export OCAMLFIND_DESTDIR
OCAMLFIND_LDCONF=ignore
export OCAMLFIND_LDCONF

%:
	dh $@ --with ocaml

# building the manual is currently broken as it needs adt_version.ml which is
# not generated
#.PHONY: override_dh_auto_build
#override_dh_auto_build:
#	dh_auto_build
#	make -C manual atd-manual.pdf atd-manual.html

.PHONY: override_dh_auto_install
override_dh_auto_install:
	mkdir -p '$(DESTDIR)/usr/bin'
	mkdir -p '$(OCAMLFIND_DESTDIR)'
	jbuilder install --destdir=$(DESTDIR) --libdir=$(OCAML_STDLIB_DIR) --verbose

.PHONY: override_dh_missing
override_dh_missing:
	dh_missing --list-missing

# override this to prevent dh_auto_clean to try make distclean,
# which creates atd_version.ml
.PHONY: override_dh_auto_clean
override_dh_auto_clean:
	$(MAKE) clean

=== debian/watch ===
version=3
https://github.com/mjambon/atd/tags .*/v?(.*)\.tar\.gz

## ocaml-atd 2.1.0

=== debian/changelog ===
ocaml-atd (2.1.0-1) unstable; urgency=medium

  * Team upload
  * New upstream release
  * Update Homepage and debian/watch
  * Bump debhelper compat level to 12
  * Bump Standards-Version to 4.5.0
  * Add Rules-Requires-Root: no

 -- Stéphane Glondu <glondu@debian.org>  Fri, 31 Jan 2020 14:14:00 +0100

=== debian/control ===
--- 
+++ 
@@ -4,24 +4,25 @@
 Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders: Hendrik Tews <hendrik@askra.de>
 Build-Depends:
-  dune (>= 1.6.2),
-  opam,
-  ocaml-nox (>= 3.11.1-3~),
-  ocaml-best-compilers,
-  ocaml-findlib,
-  dh-ocaml (>= 0.9~),
-  debhelper (>= 11),
-  menhir,
-  libeasy-format-ocaml-dev,
-  hevea,
-  camlmix,
-  libfindlib-ocaml-dev,
-  libcaml2html-ocaml-dev,
-  libbiniou-ocaml-dev (>= 1.0.6),
-  libyojson-ocaml-dev,
-  default-jdk-headless,
-Standards-Version: 4.1.4
-Homepage: https://github.com/mjambon/atd
+ debhelper-compat (= 12),
+ ocaml-nox,
+ ocaml-dune,
+ menhir,
+ libeasy-format-ocaml-dev,
+ libre-ocaml-dev,
+ libbiniou-ocaml-dev,
+ libyojson-ocaml-dev,
+# For the manual:
+ libcaml2html-ocaml-dev,
+ libfindlib-ocaml-dev,
+ hevea,
+ camlmix,
+ texlive-latex-extra,
+# For all OCaml packages:
+ dh-ocaml
+Standards-Version: 4.5.0
+Rules-Requires-Root: no
+Homepage: https://github.com/ahrefs/atd
 Vcs-Git: https://salsa.debian.org/ocaml-team/ocaml-atd.git
 Vcs-Browser: https://salsa.debian.org/ocaml-team/ocaml-atd

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
#export DH_OPTIONS=-v

include /usr/share/dpkg/pkg-info.mk
include /usr/share/ocaml/ocamlvars.mk

export PATH := $(CURDIR)/_tmp/usr/bin:$(PATH)
export OCAMLPATH := $(CURDIR)/_tmp$(OCAML_STDLIB_DIR)

DUNE_INSTALL := dune install --destdir=$(CURDIR)/_tmp --prefix=/usr --libdir=..$(OCAML_STDLIB_DIR)

%:
	dh $@ --with ocaml

override_dh_auto_clean:
	dh_auto_clean
	rm -rf _tmp

override_dh_auto_build:
	dune build -p atdgen-codec-runtime
	$(DUNE_INSTALL) atdgen-codec-runtime
	dune build -p atd
	$(DUNE_INSTALL) atd
	dune build -p atdgen-runtime
	$(DUNE_INSTALL) atdgen-runtime
	dune build -p atdgen
	$(DUNE_INSTALL) atdgen
	echo 'let version = "$(DEB_VERSION_UPSTREAM)"' > atd_version.ml
	$(MAKE) -C manual

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dune runtest -p atdgen-codec-runtime
	dune runtest -p atd
	dune runtest -p atdgen-runtime
	dune runtest -p atdgen
endif

override_dh_auto_install:
	rm -rf debian/tmp
	cp -a _tmp debian/tmp
	rm -rf debian/tmp/usr/doc/atdgen*runtime debian/tmp/usr/doc/*/LICENSE.md

override_dh_missing:
	dh_missing --fail-missing

## ocaml-atd 2.2.1

=== Makefile ===
DUNE ?= dune

all:
	$(DUNE) build

test:
	$(DUNE) runtest

check: test

js:
	$(DUNE) build atdgen/bin/ag_main.bc.js

clean:
	$(DUNE) clean

all-supported-ocaml-versions:
	$(DUNE) runtest --workspace dune-workspace.dev

doc:
	cd doc && sphinx-build . _build

livedoc:
	cd doc && sphinx-autobuild . _build \
	  -p 8888 -q  --host $(shell hostname) -r '\.#.*'

package := atd
opam-release:
	dune-release distrib --skip-build --skip-lint --skip-tests -n $(package)
	dune-release publish distrib --verbose -n $(package)
	dune-release opam pkg -n $(package)
	dune-release opam submit -n $(package)

.PHONY: all test clean check doc livedoc

=== manual/Makefile ===
--- 
+++ 
@@ -1,5 +1,3 @@
-# $Id: Makefile 52901 2010-12-10 18:47:39Z martin $
-
 # `make pdf' requires pdflatex and builds readme.pdf
 # `make txt' requires hevea and builds readme.txt
 # `make html' requires hevea and builds readme.html
@@ -22,7 +20,7 @@
 atd-manual.txt: $(addsuffix .tex, $(TEXFILES))
 	rm -f *.aux
 	hevea -fix -text atd-manual
-	cp atd-manual.txt ../README
+	iconv -f ISO_8859-1 -t UTF-8 < atd-manual.txt > ../atd-manual.txt
 
 atd-manual.html: $(addsuffix .tex, $(TEXFILES))
 	rm -f *.aux
@@ -33,5 +31,5 @@
 	pdflatex atd-manual
 
 clean:
-	rm -f *.aux *.toc *.log *.out *.haux *.htoc *.fls \
+	rm -f *.aux *.toc *.log *.out *.haux *.htoc *.fls *.mlx.ml \
 		atd-manual.pdf atd-manual.txt atd-manual.html

=== atdgen/example/Makefile ===
.PHONY: default
default:
	./example.sh

.PHONY: clean
	rm -f *.cm[iox] *.o *.annot \
		format_v[12].mli format_v[12].ml \
		upgrade_demo upgrade_demo.exe \
		old_sample.dat new_sample.dat \
		old_data.dat new_data.dat

=== debian/changelog ===
ocaml-atd (2.2.1-1build2) jammy; urgency=medium

  * No-change rebuild for ocaml abi changes.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 25 Jan 2022 11:16:55 +0100

ocaml-atd (2.2.1-1build1) hirsute; urgency=medium

  * No-change rebuild for ocaml abi changes.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 02 Nov 2020 15:15:48 +0100

ocaml-atd (2.2.1-1) unstable; urgency=medium

  * New upstream release
  * Add myself to Uploaders and remove Hendrik
  * Bump debhelper compat level to 13

 -- Stéphane Glondu <glondu@debian.org>  Thu, 20 Aug 2020 13:33:28 +0200

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,9 @@
 Section: ocaml
 Priority: optional
 Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
-Uploaders: Hendrik Tews <hendrik@askra.de>
+Uploaders: Stéphane Glondu <glondu@debian.org>
 Build-Depends:
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  ocaml-nox,
  ocaml-dune,
  menhir,

=== debian/rules ===
--- 
+++ 
@@ -44,6 +44,3 @@
 	rm -rf debian/tmp
 	cp -a _tmp debian/tmp
 	rm -rf debian/tmp/usr/doc/atdgen*runtime debian/tmp/usr/doc/*/LICENSE.md
-
-override_dh_missing:
-	dh_missing --fail-missing

=== debian/watch ===
version=3
https://github.com/ahrefs/atd/releases .*/archive/v?(.*)\.tar\.gz

## ocaml-atd 2.9.1

=== debian/changelog ===
ocaml-atd (2.9.1-2) unstable; urgency=medium

  * Team upload.
  * Package atdts.
  * Fix version detection.

 -- Julien Puydt <jpuydt@debian.org>  Sun, 17 Jul 2022 11:55:40 +0200

ocaml-atd (2.9.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.

 -- Julien Puydt <jpuydt@debian.org>  Sun, 17 Jul 2022 10:40:07 +0200

ocaml-atd (2.4.1-1) unstable; urgency=medium

  * Team upload.
  * Fix d/watch.
  * New usptream release.
  * Bump Standards-Version to 4.6.0.
  * Update d/copyright.

 -- Julien Puydt <jpuydt@debian.org>  Thu, 07 Apr 2022 10:26:02 +0200

=== debian/control ===
--- 
+++ 
@@ -8,10 +8,13 @@
  ocaml-nox,
  ocaml-dune,
  menhir,
+ libalcotest-ocaml-dev,
+ libcamlp-streams-ocaml-dev,
  libeasy-format-ocaml-dev,
  libre-ocaml-dev,
  libbiniou-ocaml-dev,
  libyojson-ocaml-dev,
+ python3-jsonschema (>= 4.6.0),
 # For the manual:
  libcaml2html-ocaml-dev,
  libfindlib-ocaml-dev,
@@ -20,7 +23,7 @@
  texlive-latex-extra,
 # For all OCaml packages:
  dh-ocaml
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: https://github.com/ahrefs/atd
 Vcs-Git: https://salsa.debian.org/ocaml-team/ocaml-atd.git
@@ -84,3 +87,12 @@
  biniou and JSON.
  .
  This package contains the shared runtime libraries (plugin).
+
+Package: atdts
+Architecture: any
+Depends: ${misc:Depends}, ${shlibs:Depends}
+Recommends: ocaml-findlib
+Description: OCaml code generator for TypeScript
+ Atdts is a command-line program that takes as input type definitions in
+ the ATD syntax and produces TypeScript classes that can read and write
+ JHSON data.

=== debian/watch ===
version=4
https://github.com/ahrefs/atd/releases .*/v?(.*)\.tar\.gz

## ocaml-atd 2.10.0

=== Makefile ===
#
# Makefile for developer's convenience.
# Build logic is implemented with dune.
#

DUNE ?= dune

# Build everything. Should only require OCaml libraries and tools installable
# via opam.
.PHONY: all
all:
	$(MAKE) -C atdpy clean-for-dune
	$(MAKE) -C atdts clean-for-dune
	$(DUNE) build

# Install the OCaml dependencies for the build.
.PHONY: setup
setup:
	opam update
	./scripts/install-opam-dependencies

# Build and test everything in a Docker container, producing an
# image named 'atd'.
# This is split into two steps because installing the dependencies takes
# forever each time.
.PHONY: docker
docker:
	$(MAKE) docker-deps
	$(MAKE) docker-build

# This takes a while and has nothing to do with atd.
.PHONY: docker-deps
docker-deps:
	docker build -t atd-deps -f dockerfiles/atd-deps.dockerfile .

.PHONY: docker-build
docker-build:
	docker build -t atd -f dockerfiles/atd.dockerfile .

############################# Testing #####################################

# Test everything. Requires external non-OCaml compilers and libraries
# to support all the target languages.
.PHONY: test
test:
	$(MAKE) test-ts
	$(MAKE) test-ocaml
	$(MAKE) test-scala
	$(MAKE) test-java
	$(MAKE) test-python
	$(MAKE) test-ts

# Test the OCaml code used by all the backends
test-common:
	$(MAKE) -C atd test
	$(MAKE) -C atdcat test

# Test only the OCaml backends
.PHONY: test-ocaml
test-ocaml:
	$(MAKE) test-common
	$(MAKE) -C atdgen-runtime test
	$(MAKE) -C atdgen test

# Test only the Scala backend
.PHONY: test-scala
test-scala:
	$(MAKE) test-common
	$(MAKE) -C atds test

# Test only the Java backend
.PHONY: test-java
test-java:
	$(MAKE) test-common
	$(MAKE) -C atdj test

# Test only the Python backend
.PHONY: test-python
test-python:
	$(MAKE) test-common
	$(MAKE) -C atdpy test

# Test only the TypeScript backend
.PHONY: test-ts
test-ts:
	$(MAKE) test-common
	$(MAKE) -C atdts test

############################################################################

.PHONY: js
js:
	$(DUNE) build atdgen/bin/ag_main.bc.js

.PHONY: clean
clean:
	$(DUNE) clean
	$(MAKE) -C atdpy clean
	rm -rf tmp

.PHONY: all-supported-ocaml-versions
all-supported-ocaml-versions:
	$(DUNE) runtest --workspace dune-workspace.dev

.PHONY: doc
doc:
	cd doc && sphinx-build . _build

# Run documentation server.
# See setup instructions in CONTRIBUTING.md
.PHONY: livedoc
livedoc:
	$(MAKE) doc
	python3 -m http.server 8888 --directory doc/_build

# Prepare the opam files for a release. They're derived from 'dune-project'
# and from the template specified in the root 'dune' file..
#
.PHONY: opam-files
opam-files:
	$(DUNE) build *.opam

# This is only part of the release process.
# See complete release instructions in CONTRIBUTING.md.
#
.PHONY: opam-release
opam-release:
	dune-release tag
	dune-release distrib
	dune-release publish
	dune-release opam pkg
	dune-release opam submit

=== atd/Makefile ===
DUNE ?= dune

.PHONY: build
build:
	$(DUNE) build @all

.PHONY: test
test:
	$(DUNE) runtest -f

=== atdj/Makefile ===
#
# Java/JSON backend
#

DUNE ?= dune

.PHONY: build
build:
	$(DUNE) build @all

.PHONY: test
test:
	$(DUNE) runtest -f

=== atdpy/Makefile ===
#
# Python-mypy/JSON backend
#

DUNE ?= dune

.PHONY: build
build:
	rm -f bin/atdpy
	$(MAKE) clean-for-dune
	$(DUNE) build @all
	mkdir -p bin
	ln -s ../../_build/install/default/bin/atdpy bin/atdpy

# The symlink facilitates the development of test code that depends on the
# generated code.
.PHONY: test
test:
	$(MAKE) clean-for-dune
	$(DUNE) runtest -f; status=$$?; \
	  ln -s ../../../_build/default/atdpy/test/python-tests/everything.py \
	    test/python-tests/everything.py && \
	  exit "$$status"

.PHONY: clean-for-dune
clean-for-dune:
	rm -f test/python-tests/everything.py

.PHONY: clean
clean:
	$(MAKE) clean-for-dune
	$(DUNE) clean
	rm -rf bin

=== atdts/test/ts-tests/Makefile ===
JS ?= js

.PHONY: test
test:
	# Install TypeScript and JavaScript dependencies locally
	npm install
	# Compile TypeScript (handwritten + generated by atdts) to JavaScript
	npm run tsc
	# Run the resulting code (compiled from TypeScript)
	$(JS) manual_sample.js
	$(JS) test_atdts.js

.PHONY: clean
clean:
	git clean -dfX

=== debian/changelog ===
ocaml-atd (2.10.0-2) unstable; urgency=medium

  * Tighten the b-dep on yojson.
  * Fix d/watch.

 -- Julien Puydt <jpuydt@debian.org>  Sun, 23 Oct 2022 22:08:49 +0200

ocaml-atd (2.10.0-1) experimental; urgency=medium

  * New upstream release.
  * Bump standards-version to 4.6.1.
  * Refresh patches.

 -- Julien Puydt <jpuydt@debian.org>  Fri, 12 Aug 2022 21:50:20 +0200

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
  libeasy-format-ocaml-dev,
  libre-ocaml-dev,
  libbiniou-ocaml-dev,
- libyojson-ocaml-dev,
+ libyojson-ocaml-dev (>= 2.0.2),
  python3-jsonschema (>= 4.6.0),
 # For the manual:
  libcaml2html-ocaml-dev,
@@ -23,7 +23,7 @@
  texlive-latex-extra,
 # For all OCaml packages:
  dh-ocaml
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Homepage: https://github.com/ahrefs/atd
 Vcs-Git: https://salsa.debian.org/ocaml-team/ocaml-atd.git

=== debian/rules ===
--- 
+++ 
@@ -21,6 +21,7 @@
 	rm -rf _tmp
 
 override_dh_auto_build:
+	echo 'let version = "$(DEB_VERSION_UPSTREAM)"' > atd/src/version.ml
 	dune build -p atdgen-codec-runtime
 	$(DUNE_INSTALL) atdgen-codec-runtime
 	dune build -p atd
@@ -29,7 +30,8 @@
 	$(DUNE_INSTALL) atdgen-runtime
 	dune build -p atdgen
 	$(DUNE_INSTALL) atdgen
-	echo 'let version = "$(DEB_VERSION_UPSTREAM)"' > atd_version.ml
+	dune build -p atdts
+	$(DUNE_INSTALL) atdts
 	$(MAKE) -C manual
 
 override_dh_auto_test:
@@ -38,6 +40,7 @@
 	dune runtest -p atd
 	dune runtest -p atdgen-runtime
 	dune runtest -p atdgen
+	dune runtest -p atdts
 endif
 
 override_dh_auto_install:

=== debian/watch ===
version=4
https://github.com/ahrefs/atd/tags .*/v?(.*)\.tar\.gz

## ocaml-atd 2.12.0

=== debian/changelog ===
ocaml-atd (2.12.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Bump standards-version to 4.6.2
  * Fix compilation with recent dune

 -- Julien Puydt <jpuydt@debian.org>  Thu, 06 Jul 2023 12:06:39 +0200

=== debian/control ===
--- 
+++ 
@@ -23,7 +23,7 @@
  texlive-latex-extra,
 # For all OCaml packages:
  dh-ocaml
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://github.com/ahrefs/atd
 Vcs-Git: https://salsa.debian.org/ocaml-team/ocaml-atd.git

=== debian/rules ===
--- 
+++ 
@@ -11,7 +11,7 @@
 export PATH := $(CURDIR)/_tmp/usr/bin:$(PATH)
 export OCAMLPATH := $(CURDIR)/_tmp$(OCAML_STDLIB_DIR)
 
-DUNE_INSTALL := dune install --destdir=$(CURDIR)/_tmp --prefix=/usr --libdir=..$(OCAML_STDLIB_DIR)
+DUNE_INSTALL := dune install --destdir=$(CURDIR)/_tmp --prefix=/usr --libdir=$(OCAML_STDLIB_DIR)
 
 %:
 	dh $@ --with ocaml

## ocaml-atd 2.15.0

=== Makefile ===
--- 
+++ 
@@ -10,6 +10,7 @@
 .PHONY: all
 all:
 	$(MAKE) -C atdpy clean-for-dune
+	$(MAKE) -C atdd clean-for-dune
 	$(MAKE) -C atdts clean-for-dune
 	$(DUNE) build
 
@@ -43,17 +44,19 @@
 # to support all the target languages.
 .PHONY: test
 test:
-	$(MAKE) test-ts
 	$(MAKE) test-ocaml
 	$(MAKE) test-scala
 	$(MAKE) test-java
 	$(MAKE) test-python
 	$(MAKE) test-ts
+	$(MAKE) test-d
+
 
 # Test the OCaml code used by all the backends
 test-common:
 	$(MAKE) -C atd test
 	$(MAKE) -C atdcat test
+	$(MAKE) -C atddiff test
 
 # Test only the OCaml backends
 .PHONY: test-ocaml
@@ -85,6 +88,11 @@
 test-ts:
 	$(MAKE) test-common
 	$(MAKE) -C atdts test
+
+.PHONY: test-d
+test-d:
+	$(MAKE) test-common
+	$(MAKE) -C atdd test
 
 ############################################################################

=== atdd/Makefile ===
#
# Dlang/JSON backend
#

DUNE ?= dune

.PHONY: build
build:
	rm -f bin/atdd
	$(MAKE) clean-for-dune
	$(DUNE) build @all
	mkdir -p bin
	ln -s ../../_build/install/default/bin/atdd bin/atdd

# The symlink facilitates the development of test code that depends on the
# generated code.
.PHONY: test
test:
	$(MAKE) clean-for-dune
	$(DUNE) runtest -f; status=$$?; \
	  ln -s ../../../_build/default/atdd/test/dlang-tests/everything.d \
	    test/dlang-tests/everything.d && \
	  exit "$$status"

.PHONY: clean-for-dune
clean-for-dune:
	rm -f test/dlang-tests/everything.d

.PHONY: clean
clean:
	$(MAKE) clean-for-dune
	$(DUNE) clean
	rm -rf bin

=== atdts/Makefile ===
#
# TypeScript/JSON backend
#

DUNE ?= dune

.PHONY: build
build:
	rm -f bin/atdts
	$(MAKE) clean-for-dune
	$(DUNE) build @all
	mkdir -p bin
	ln -s ../../_build/install/default/bin/atdts bin/atdts

# The symlink facilitates the development of test code that depends on the
# generated code.
.PHONY: test
test:
	$(MAKE) clean-for-dune
	# Run atdts to convert ATD -> TypeScript
	$(DUNE) runtest -f; status=$$?; \
          if [ "$$status" != 0 ]; then \
            echo "Run 'dune promote' to accept diffs, if any."; \
          fi; \
	  ln -s ../../../_build/default/atdts/test/ts-tests/everything.ts \
	    test/ts-tests/everything.ts && \
	  exit "$$status"
	# Compile and run the TypeScript code
	$(MAKE) -C test/ts-tests

.PHONY: clean-for-dune
clean-for-dune:
	rm -f test/ts-tests/everything.ts

.PHONY: clean
clean:
	$(MAKE) clean-for-dune
	$(DUNE) clean
	rm -rf bin

=== doc/requirements.txt ===
# We use cloud_sptheme because it allows advanced tables
sphinx
cloud_sptheme

=== atddiff/test/Makefile ===
# Run the tests.

DUNE ?= dune

# We generate the dune files from the list of *_old.atd files because
# dune doesn't support dynamic targets.
#
# How to add a test?
#
# 1. Identify the folder corresponding to the atddiff options to be used.
#    Look into the script 'generate-dune-rules' to find out which folder
#    corresponds to which options.
# 2. Create a pair of files ${name}_old.atd and ${name}_new.atd in that
#    folder.
# 3. Run 'make'.
# 4. If you're satisfied with the output, run 'dune promote' to make it the
#    new reference for future tests.
#
.PHONY: test
test:
	./generate-dune-rules
	$(DUNE) runtest -f

=== debian/changelog ===
ocaml-atd (2.15.0-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Sun, 18 Feb 2024 11:40:42 +0100

ocaml-atd (2.14.1-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Tue, 24 Oct 2023 08:32:12 +0200

ocaml-atd (2.12.0-3) unstable; urgency=medium

  * Mark <!nocheck> build-dependencies
  * Depend on ocaml instead of transitional ocaml-nox

 -- Stéphane Glondu <glondu@debian.org>  Sun, 10 Sep 2023 06:10:04 +0200

ocaml-atd (2.12.0-2) unstable; urgency=medium

  * Use ocaml_dune DH buildsystem

 -- Stéphane Glondu <glondu@debian.org>  Sun, 06 Aug 2023 09:33:22 +0200

=== debian/control ===
--- 
+++ 
@@ -5,10 +5,10 @@
 Uploaders: Stéphane Glondu <glondu@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
- ocaml-nox,
+ ocaml,
  ocaml-dune,
  menhir,
- libalcotest-ocaml-dev,
+ libalcotest-ocaml-dev <!nocheck>,
  libcamlp-streams-ocaml-dev,
  libeasy-format-ocaml-dev,
  libre-ocaml-dev,
@@ -22,7 +22,7 @@
  camlmix,
  texlive-latex-extra,
 # For all OCaml packages:
- dh-ocaml
+ dh-ocaml (>= 1.2.2)
 Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://github.com/ahrefs/atd

=== debian/watch ===
version=4
opts="searchmode=plain" \
https://api.github.com/repos/ahrefs/atd/releases?per_page=50 \
https://github.com/ahrefs/atd/releases/download/[^/]+/atd-@ANY_VERSION@.tbz
